<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML3.2 EN">
<HTML>
<HEAD>
<META NAME="GENERATOR" CONTENT="DOCTEXT">
<TITLE>SNESSetFromOptions</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF">
<A NAME="SNESSetFromOptions"><H1>SNESSetFromOptions</H1></A>
Sets various <A HREF="../SNES/SNES.html#SNES">SNES</A> and <A HREF="../KSP/KSP.html#KSP">KSP</A> parameters from user options. 
<H3><FONT COLOR="#CC3333">Synopsis</FONT></H3>
<PRE>
#include "petscsnes.h"  
PetscErrorCode PETSCSNES_DLLEXPORT SNESSetFromOptions(SNES snes)
</PRE>
Collective on <A HREF="../SNES/SNES.html#SNES">SNES</A>
<P>
<H3><FONT COLOR="#CC3333">Input Parameter</FONT></H3>
<DT><B>snes </B> -the <A HREF="../SNES/SNES.html#SNES">SNES</A> context
<br>
<P>
<H3><FONT COLOR="#CC3333">Options Database Keys</FONT></H3>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_type &lt;type&gt; </B></TD><TD>- ls, tr, umls, umtr, test
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_stol </B></TD><TD>- convergence tolerance in terms of the norm
of the change in the solution between steps
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_atol &lt;abstol&gt; </B></TD><TD>- absolute tolerance of residual norm
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_rtol &lt;rtol&gt; </B></TD><TD>- relative decrease in tolerance norm from initial
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_max_it &lt;max_it&gt; </B></TD><TD>- maximum number of iterations
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_max_funcs &lt;max_funcs&gt; </B></TD><TD>- maximum number of function evaluations
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_max_fail &lt;max_fail&gt; </B></TD><TD>- maximum number of failures
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_trtol &lt;trtol&gt; </B></TD><TD>- trust region tolerance
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_no_convergence_test </B></TD><TD>- skip convergence test in nonlinear 
solver; hence iterations will continue until max_it
or some other criterion is reached. Saves expense
of convergence test
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_monitor &lt;optional filename&gt; </B></TD><TD>- prints residual norm at each iteration. if no
filename given prints to stdout
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_vecmonitor </B></TD><TD>- plots solution at each iteration
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_vecmonitor_update </B></TD><TD>- plots update to solution at each iteration 
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_xmonitor </B></TD><TD>- plots residual norm at each iteration 
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_fd </B></TD><TD>- use finite differences to compute Jacobian; very slow, only for testing
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_mf_ksp_monitor </B></TD><TD>- if using matrix-free multiply then print h at each <A HREF="../KSP/KSP.html#KSP">KSP</A> iteration
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_print_converged_reason </B></TD><TD>- print the reason for convergence/divergence after each solve
</TD></TR></TABLE>
<P>
<H3><FONT COLOR="#CC3333">Options Database for Eisenstat-Walker method</FONT></H3>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_ksp_ew_conv </B></TD><TD>- use Eisenstat-Walker method for determining linear system convergence
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_ksp_ew_version ver </B></TD><TD>- version of  Eisenstat-Walker method
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_ksp_ew_rtol0 &lt;rtol0&gt; </B></TD><TD>- Sets rtol0
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_ksp_ew_rtolmax &lt;rtolmax&gt; </B></TD><TD>- Sets rtolmax
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_ksp_ew_gamma &lt;gamma&gt; </B></TD><TD>- Sets gamma
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_ksp_ew_alpha &lt;alpha&gt; </B></TD><TD>- Sets alpha
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_ksp_ew_alpha2 &lt;alpha2&gt; </B></TD><TD>- Sets alpha2 
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>-snes_ksp_ew_threshold &lt;threshold&gt; </B></TD><TD>- Sets threshold
</TD></TR></TABLE>
<P>
<H3><FONT COLOR="#CC3333">Notes</FONT></H3>
To see all options, run your program with the -help option or consult
the users manual.
<P>

<P>
<H3><FONT COLOR="#CC3333">Keywords</FONT></H3>
 <A HREF="../SNES/SNES.html#SNES">SNES</A>, nonlinear, set, options, database
<BR>
<P>
<H3><FONT COLOR="#CC3333">See Also</FONT></H3>
 <A HREF="../SNES/SNESSetOptionsPrefix.html#SNESSetOptionsPrefix">SNESSetOptionsPrefix</A>()
<BR><P><B><P><B><FONT COLOR="#CC3333">Level:</FONT></B>beginner
<BR><FONT COLOR="#CC3333">Location:</FONT></B><A HREF="../../../src/snes/interface/snes.c.html#SNESSetFromOptions">src/snes/interface/snes.c</A>
<BR><A HREF="./index.html">Index of all SNES routines</A>
<BR><A HREF="../../index.html">Table of Contents for all manual pages</A>
<BR><A HREF="../singleindex.html">Index of all manual pages</A>
<P><H3><FONT COLOR="#CC3333">Examples</FONT></H3>
<A HREF="../../../src/snes/examples/tutorials/ex1.c.html">src/snes/examples/tutorials/ex1.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex2.c.html">src/snes/examples/tutorials/ex2.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex3.c.html">src/snes/examples/tutorials/ex3.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex5.c.html">src/snes/examples/tutorials/ex5.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex5s.c.html">src/snes/examples/tutorials/ex5s.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex6.c.html">src/snes/examples/tutorials/ex6.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex14.c.html">src/snes/examples/tutorials/ex14.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex21.c.html">src/snes/examples/tutorials/ex21.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex26.c.html">src/snes/examples/tutorials/ex26.c.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex1f.F.html">src/snes/examples/tutorials/ex1f.F.html</A><BR>
<A HREF="../../../src/snes/examples/tutorials/ex5f.F.html">src/snes/examples/tutorials/ex5f.F.html</A><BR>
</BODY></HTML>
